UpgradeList = LibStub("AceAddon-3.0"):NewAddon("UpgradeList", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("UpgradeList")

local UPGRADELIST_VERSION = GetAddOnMetadata('UpgradeList', 'Version')

local LSM = LibStub("LibSharedMedia-3.0")


-- Register some media
LSM:Register("sound", "Dungeon Ready", [[Sound\Interface\levelup2.wav]])
LSM:Register("sound", "Level Up", [[Sound\Interface\LevelUp.wav]])
LSM:Register("sound", "Capture Flag", [[Sound\Interface\PVPFlagCapturedHordeMono.wav]])
LSM:Register("sound", "Horde Flag Taken", [[Sound\Interface\PVPFlagTakenHordeMono.wav]])
LSM:Register("sound", "Alliance Flag Taken", [[Sound\Interface\PVPFlagTakenMono.wav]])
LSM:Register("sound", "Ready?", [[Sound\Interface\ReadyCheck.wav]])
LSM:Register("sound", "Whip", [[Sound\Item\Weapons\Whip\BullWhipHit1.wav]])
LSM:Register("sound", "Puppy Bark", [[Sound\Emitters\Emitter_Dalaran_Petstore_Puppy_07.wav]])
LSM:Register("sound", "Squire Horn", [[Sound\Events\squire_horn_aa.wav]])
LSM:Register("sound", "Zelda-Heart Piece", [[Interface\Addons\UpgradeList\Sounds\LTTP_Get_HeartPiece.ogg]]) 
LSM:Register("sound", "Zelda-Item", [[Interface\Addons\UpgradeList\Sounds\LTTP_ItemFanfare_Stereo.ogg]]) 
LSM:Register("sound", "Zelda-Rupee", [[Interface\Addons\UpgradeList\Sounds\LTTP_Rupee1.ogg]]) 
LSM:Register("sound", "Zelda-Secret", [[Interface\Addons\UpgradeList\Sounds\LTTP_Secret.ogg]]) 


local displaychoices = {
	chatwindow = "Chat Window",
	scrollwindow = "Message Window",
}

local autodeletechoices = {
	[1] = "Assume acquired item is for Primary Spec list",
	[2] = "Assume acquired item is for Secondary Spec list",
	[3] = "Do nothing",
	[4] = "Ask me which spec the acquired item is for",
}

local onehandweaponchoices = {
	[1] = "Assume acquired weapon is for Main Hand list",
	[2] = "Assume acquired weapon is for Off Hand list",
	[3] = "Do nothing",
	[4] = "Ask me which list the acquired weapon is for",
}

local options = {
	name = "Upgrade List",
	handler = UpgradeList,
	type = 'group',
	args = {
		togglebutton = { 
			type = "execute",
			name = "Open Upgrade List",
			order = 1,
			desc = "This button will Open the Upgrade List addon.",
			func = "OpenUpgradeList",
		},
		lockframe = { --option is UpgradeListDBVar.profile.mainframe.lock
			type = "toggle",
			name = "Lock",
			desc = "Lock the Upgrade List frame.",
			order = 2,
			get = "MainFrameMovableGet",
			set = "MainFrameMovableSet",
		},
		minimapbutton = { --option is UpgradeListDBVar.profile.minimap.hide
			type = "toggle",
			name = "Hide Minimap Button",
			order = 3,
			get = "MinimapButtonGet",
			set = "MinimapButtonSet",
		},
		scale = { --option is UpgradeListDBVar.profile.mainframe.scale
			type = "range",
			name = "Scale",
			min = 0.01,
			max = 2,
			bigStep = 0.01,
			isPercent = true,
			get = "ScaleGet",
			set = "ScaleSet",
			order = 4,
			width = "full",
		},
		header = {
			name = "Detected Upgrade Options",
			type = "header",
			order = 5,
		},
		alertmessagepotential = { --option is UpgradeListDBVar.profile.messages.potential
			name = "Enable Messages",
			type = "toggle",
			desc = "Enable to allow Upgrade List to send you a message if an item on your list is detected.",
			order = 6,
			get = "AlertMessagePotentialGet",
			set = "AlertMessagePotentialSet",
		},
		alertmessagespotentialdropdown = { --option is UpgradeListDBVar.profile.messages.potentiallocation
			name = "Message Location:",
			type = "select",
			desc = "Select where you would like Upgrade List to display messages about detected upgrades.",
			values = displaychoices,
			get = "AlertMessagePotentialDropdownGet",
			set = "AlertMessagePotentialDropdownSet",
			style = "dropdown",
			order = 7,
			disabled = "DisableMessagePotentialDropdown",
		},
		alertsoundpotential = { --option is UpgradeListDBVar.profile.sound.potential
			name = "Enable Sound",
			type = "toggle",
			desc = "Enable to allow Upgrade List to play a sound if an item on your list is detected.",
			order = 8,
			get = "AlertSoundPotentialGet",
			set = "AlertSoundPotentialSet",
		},
		alertsoundpotentialdropdown = { --option is UpgradeListDBVar.profile.sound.potentialchoice
			name = "Sound:",
			type = "select",
			dialogControl = "LSM30_Sound",
			desc = "Select the sound you want to play when an item on your list is detected.",
			values = AceGUIWidgetLSMlists.sound,
			get = "AlertSoundPotentialDropdownGet",
			set = "AlertSoundPotentialDropdownSet",
			style = "dropdown",
			order = 9,
			disabled = "DisableSoundPotentialDropdown",
		},
		header2 = {
			name = "Acquired Upgrade Options",
			type = "header",
			order = 10,
		},
		alertmessageacquired = { --option is UpgradeListDBVar.profile.messages.acquired
			name = "Enable Messages",
			type = "toggle",
			desc = "Enable to allow Upgrade List to send you a message if an item on your list is acquired.",
			order = 11,
			get = "AlertMessageAcquiredGet",
			set = "AlertMessageAcquiredSet",
		},
		alertmessagesacquireddropdown = { --option is UpgradeListDBVar.profile.messages.acquiredlocation
			name = "Message Location:",
			type = "select",
			desc = "Select where you would like Upgrade List to display messages about acquired upgrades.",
			values = displaychoices,
			get = "AlertMessageAcquiredDropdownGet",
			set = "AlertMessageAcquiredDropdownSet",
			style = "dropdown",
			order = 12,
			disabled = "DisableMessageAcquiredDropdown",
		},
		alertsoundacquired = { --option is UpgradeListDBVar.profile.sound.acquired
			name = "Enable Sound",
			type = "toggle",
			desc = "Enable to allow Upgrade List to play a sound if an item on your list is acquired.",
			order = 13,
			get = "AlertSoundAcquiredGet",
			set = "AlertSoundAcquiredSet",
		},
		alertsoundacquireddropdown = { --option is UpgradeListDBVar.profile.sound.acquiredchoice
			name = "Sound:",
			type = "select",
			dialogControl = "LSM30_Sound",
			desc = "Select the sound you want to play when an item on your list is acquired.",
			values = AceGUIWidgetLSMlists.sound,
			get = "AlertSoundAcquiredDropdownGet",
			set = "AlertSoundAcquiredDropdownSet",
			style = "dropdown",
			order = 14,
			disabled = "DisableSoundAcquiredDropdown",
		},
		header3 = {
			name = "Auto-Delete Options",
			type = "header",
			order = 15,
		},
		autodelete = { --option is UpgradeListDBVar.profile.autodelete.enable
			name = "Enable Auto-Delete",
			type = "toggle",
			desc = "Enable to allow Upgrade List to auto-delete acquired items along with items of a lower priority (excluding items in the \"Other\" tab).",
			order = 16,
			get = "AutoDeleteGet",
			set = "AutoDeleteSet",
			width = "full",
		},
		autodeletemessage = { --option is UpgradeListDBVar.profile.autodelete.messages
			name = "Enable Messages",
			type = "toggle",
			desc = "Enable to allow Upgrade List to send you a message when it auto-deletes items from your list.",
			order = 17,
			get = "AutoDeleteMessageGet",
			set = "AutoDeleteMessageSet",
			disabled = "DisableAutoDeleteMessage",
		},
		autodeletemessagedropdown = { --option is UpgradeListDBVar.profile.autodelete.messagelocation
			name = "Message Location:",
			type = "select",
			desc = "Select where you would like Upgrade List to display messages about auto-deletion.",
			values = displaychoices,
			get = "AutoDeleteMessageDropdownGet",
			set = "AutoDeleteMessageDropdownSet",
			style = "dropdown",
			order = 18,
			disabled = "DisableAutoDeleteMessageDropdown",
		},
		ignorerings = {
			name = "Ignore Rings",
			type = "toggle",
			desc = "Check this option to make Upgrade List ignore Rings when auto-deleting.",
			order = 19,
			get = "IgnoreRingsGet",
			set = "IgnoreRingsSet",
			disabled = "DisableIgnoreRings",
		},
		ignoretrinkets = {
			name = "Ignore Trinkets",
			type = "toggle",
			desc = "Check this option to make Upgrade List ignore Trinkets when auto-deleting.",
			order = 20,
			get = "IgnoreTrinketsGet",
			set = "IgnoreTrinketsSet",
			disabled = "DisableIgnoreTrinkets",
		},
		autodeletedescription = {
			name = "When auto-deleting, if an item is on both the primary spec list and secondary spec list:",
			order = 21,
			type = "description",
			width = "double",
			fontSize = "medium",
		},
		autodeletechoicedropdown = { --option is UpgradeListDBVar.profile.autodelete.choice
			name = "Select action:",
			type = "select",
			desc = "Select how you would like Upgrade List to handle items in both spec lists.",
			values = autodeletechoices,
			get = "AutoDeleteChoiceDropdownGet",
			set = "AutoDeleteChoiceDropdownSet",
			style = "radio",
			order = 22,
			width = "double",
			disabled = "DisableAutoDeleteChoiceDropdown",
		},
		header4 = {
			name = "One-Handed Weapon Options",
			type = "header",
			order = 23,
		},
		onehandweapondescription = {
			name = "When you receive a 1-handed weapon, if it is on your Main Hand list and your Off Hand list:",
			order = 24,
			type = "description",
			width = "double",
			fontSize = "medium",
		},
		onehandweaponchoicedropdown = {
			name = "Select action:",
			type = "select",
			desc = "Select how you would like Upgrade List to handle 1-handed weapons in both main hand and off hand lists.",
			values = onehandweaponchoices,
			get = "OneHandWeaponChoiceDropdownGet",
			set = "OneHandWeaponChoiceDropdownSet",
			style = "radio",
			order = 25,
			width = "double",
		},
		header5 = {
			name = "Database Options",
			type = "header",
			order = 26,
		},
		deletebutton = { 
			type = "execute",
			name = "Delete ALL Data",
			order = 27,
			desc = "Delete ALL DATA in all tabs in both specs?",
			func = "ResetDatabase",
			confirm = true,
		},
	},
}

local defaults = { 
	char = {
		PrimarySpecList = {
			Head = {
				Row = { },
				Count = 1,
			},
			Neck = {
				Row = {	},
				Count = 1,
			},
			Shoulder = {
				Row = {	},
				Count = 1,
			},
			Back = {
				Row = {	},
				Count = 1,
			},
			Chest = {
				Row = {	},
				Count = 1,
			},
			Wrist = {
				Row = {	},
				Count = 1,
			},
			Hand = {
				Row = {	},
				Count = 1,
			},
			Waist = {
				Row = {	},
				Count = 1,
			},
			Leg = {
				Row = {	},
				Count = 1,
			},
			Foot = {
				Row = {	},
				Count = 1,
			},
			Ring = {
				Row = {	},
				Count = 1,
			},
			Trinket = {
				Row = {	},
				Count = 1,
			},
			Main = {
				Row = {	},
				Count = 1,
			},
			Off = {
				Row = {	},
				Count = 1,
			},
			Ranged = {
				Row = {	},
				Count = 1,
			},
			Other = {
				Row = {	},
				Count = 1,
			},
		},
		SecondarySpecList = {
			Head = {
				Row = {	},
				Count = 1,
			},
			Neck = {
				Row = {	},
				Count = 1,
			},
			Shoulder = {
				Row = {	},
				Count = 1,
			},
			Back = {
				Row = {	},
				Count = 1,
			},
			Chest = {
				Row = {	},
				Count = 1,
			},
			Wrist = {
				Row = {	},
				Count = 1,
			},
			Hand = {
				Row = {	},
				Count = 1,
			},
			Waist = {
				Row = {	},
				Count = 1,
			},
			Leg = {
				Row = {	},
				Count = 1,
			},
			Foot = {
				Row = {	},
				Count = 1,
			},
			Ring = {
				Row = {	},
				Count = 1,
			},
			Trinket = {
				Row = {	},
				Count = 1,
			},
			Main = {
				Row = {	},
				Count = 1,
			},
			Off = {
				Row = {	},
				Count = 1,
			},
			Ranged = {
				Row = {	},
				Count = 1,
			},
			Other = {
				Row = {	},
				Count = 1,
			},
		},
		SavedOptions = {
			PrimaryCheck = nil,
			SecondaryCheck = nil,
			SelectedInstance = nil,
			SelectedBoss = nil,
			SelectedDifficulty = nil,
			tableUL = nil,
		},
	},
	profile = {
		ignoreflags = {
			rings = false,
			trinkets = false,
		},
		minimap = {
			hide = false,
		},
		mainframe = {
			lock = false,
			scale = 1.0,
			showoptions = true,
		},
		messages = {
			potential = true,
			potentiallocation = "scrollwindow",
			acquired = true,
			acquiredlocation = "scrollwindow",
			scrollwindow = nil,
		},
		sound = {
			potential = true,
			potentialchoice = "None",
			acquired = true,
			acquiredchoice = "None",
		},
		autodelete = {
			enable = true,
			messages = true,
			messagelocation = "chatwindow",
			choice = 1,
		},
		onehandweapon = {
			choice = 1,
		},
	},
}

UpgradeListLDB = LibStub("LibDataBroker-1.1"):NewDataObject("UpgradeList", {
	type = "launcher",
	label = "Upgrade List",
	icon = "Interface\\Icons\\Achievement_BG_returnXflags_def_WSG",
})


function UpgradeListLDB.OnClick(self, button)
	if (button == "LeftButton") then
		UpgradeList:OpenUpgradeList()
	else
		InterfaceOptionsFrame_OpenToCategory(UpgradeList.optionsFrame)
	end
end

local icon = LibStub("LibDBIcon-1.0")

function UpgradeList:OnInitialize()
	UpgradeListDBVar = LibStub("AceDB-3.0"):New("UpgradeListDB", defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("UpgradeList", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("UpgradeList", "Upgrade List")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("UpgradeList-Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(UpgradeListDBVar))
	self.profilesFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("UpgradeList-Profiles", "Profiles", "Upgrade List")
	icon:Register("UpgradeListLDB", UpgradeListLDB, UpgradeListDBVar.profile.minimap)
	self:RegisterChatCommand("upgradelist", "ChatCommand")
	self:RegisterChatCommand("ul", "ChatCommand")
	UpgradeListDBVar.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	UpgradeListDBVar.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	UpgradeListDBVar.RegisterCallback(self, "OnProfileReset", "RefreshConfig")
end

function UpgradeList:RefreshConfig()

	if UpgradeListDBVar.profile.minimap.hide then
		icon:Hide("UpgradeListLDB");
	else
		icon:Show("UpgradeListLDB");
	end
	--[[
	if UpgradeListDBVar.profile.mainframe.lock then
		UpgradeListMainFrame:SetMovable(false);
		UpgradeListMainFrame:EnableMouse(false);
	else
		UpgradeListMainFrame:SetMovable(true);
		UpgradeListMainFrame:EnableMouse(true);
	end
	UpgradeListMainFrame:SetScale(UpgradeListDBVar.profile.mainframe.scale);
	if not DropDown_InitializeDropDown(self, level) then
		DropDown_InitializeDropDown(self, level)
	end
	--]]
	UpgradeList:Disable()
	UpgradeList:Enable()
end

local waitTable = {};
local waitFrame = nil;

local function UpgradeList_wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end

--[[
function UpgradeList:Wait(seconds)
	local tstart = GetTime()
	local tend = tstart + seconds
	while (tend > GetTime()) do
	end
end
--]]

function UpgradeList:LoadItemIntoCache(item)
	GetItemInfo(item:GetText());
end

function UpgradeList:ChatCommand(input)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(UpgradeList, "ul", "upgradelist", input)
	end
end

function UpgradeList:MainFrameMovableGet(info)
	return UpgradeListDBVar.profile.mainframe.lock;
end

function UpgradeList:MainFrameMovableSet(info, value)
	UpgradeListDBVar.profile.mainframe.lock = not UpgradeListDBVar.profile.mainframe.lock;
	if UpgradeListDBVar.profile.mainframe.lock then
		UpgradeListMainFrame:SetMovable(false);
		UpgradeListMainFrame:EnableMouse(false);
	else
		UpgradeListMainFrame:SetMovable(true);
		UpgradeListMainFrame:EnableMouse(true);
	end
end

function UpgradeList:MinimapButtonGet(info)
	return UpgradeListDBVar.profile.minimap.hide;
end

function UpgradeList:MinimapButtonSet(info, value)
	UpgradeListDBVar.profile.minimap.hide = not UpgradeListDBVar.profile.minimap.hide;
	if UpgradeListDBVar.profile.minimap.hide then
		icon:Hide("UpgradeListLDB");
	else
		icon:Show("UpgradeListLDB");
	end
end

function UpgradeList:ScaleGet(info)
	return UpgradeListDBVar.profile.mainframe.scale;
end

function UpgradeList:ScaleSet(info, value)
	UpgradeListMainFrame:SetScale(value);
	UpgradeListDBVar.profile.mainframe.scale = value;
end

function UpgradeList:AlertMessagePotentialGet(info)
	return UpgradeListDBVar.profile.messages.potential;
end

function UpgradeList:AlertMessagePotentialSet(info, value)
	UpgradeListDBVar.profile.messages.potential = not UpgradeListDBVar.profile.messages.potential
end

function UpgradeList:AlertMessagePotentialDropdownGet(info)
	return UpgradeListDBVar.profile.messages.potentiallocation;
end

function UpgradeList:AlertMessagePotentialDropdownSet(info, value)
	UpgradeListDBVar.profile.messages.potentiallocation = value;
end

function UpgradeList:DisableMessagePotentialDropdown()
	if UpgradeListDBVar.profile.messages.potential then
		return false
	else
		return true
	end
end

function UpgradeList:AlertSoundPotentialGet(info)
	return UpgradeListDBVar.profile.sound.potential;
end

function UpgradeList:AlertSoundPotentialSet(info, value)
	UpgradeListDBVar.profile.sound.potential = not UpgradeListDBVar.profile.sound.potential
end

function UpgradeList:AlertSoundPotentialDropdownGet(info)
	return UpgradeListDBVar.profile.sound.potentialchoice;
end

function UpgradeList:AlertSoundPotentialDropdownSet(info, value)
	UpgradeListDBVar.profile.sound.potentialchoice = value;
end

function UpgradeList:DisableSoundPotentialDropdown()
	if UpgradeListDBVar.profile.sound.potential then
		return false
	else
		return true
	end
end

function UpgradeList:AlertMessageAcquiredGet(info)
	return UpgradeListDBVar.profile.messages.acquired;
end

function UpgradeList:AlertMessageAcquiredSet(info, value)
	UpgradeListDBVar.profile.messages.acquired = not UpgradeListDBVar.profile.messages.acquired
end

function UpgradeList:AlertMessageAcquiredDropdownGet(info)
	return UpgradeListDBVar.profile.messages.acquiredlocation;
end

function UpgradeList:AlertMessageAcquiredDropdownSet(info, value)
	UpgradeListDBVar.profile.messages.acquiredlocation = value;
end

function UpgradeList:DisableMessageAcquiredDropdown()
	if UpgradeListDBVar.profile.messages.acquired then
		return false
	else
		return true
	end
end

function UpgradeList:AlertSoundAcquiredGet(info)
	return UpgradeListDBVar.profile.sound.acquired;
end

function UpgradeList:AlertSoundAcquiredSet(info, value)
	UpgradeListDBVar.profile.sound.acquired = not UpgradeListDBVar.profile.sound.acquired
end

function UpgradeList:AlertSoundAcquiredDropdownGet(info)
	return UpgradeListDBVar.profile.sound.acquiredchoice;
end

function UpgradeList:AlertSoundAcquiredDropdownSet(info, value)
	UpgradeListDBVar.profile.sound.acquiredchoice = value;
end

function UpgradeList:DisableSoundAcquiredDropdown()
	if UpgradeListDBVar.profile.sound.acquired then
		return false
	else
		return true
	end
end

function UpgradeList:AutoDeleteGet(info)
	return UpgradeListDBVar.profile.autodelete.enable;
end

function UpgradeList:AutoDeleteSet(info, value)
	UpgradeListDBVar.profile.autodelete.enable = not UpgradeListDBVar.profile.autodelete.enable
end

function UpgradeList:AutoDeleteMessageGet(info)
	return UpgradeListDBVar.profile.autodelete.messages;
end

function UpgradeList:AutoDeleteMessageSet(info, value)
	UpgradeListDBVar.profile.autodelete.messages = not UpgradeListDBVar.profile.autodelete.messages
end

function UpgradeList:DisableAutoDeleteMessage()
	if UpgradeListDBVar.profile.autodelete.enable then
		return false
	else
		return true
	end
end

function UpgradeList:AutoDeleteMessageDropdownGet(info)
	return UpgradeListDBVar.profile.autodelete.messagelocation;
end

function UpgradeList:AutoDeleteMessageDropdownSet(info, value)
	UpgradeListDBVar.profile.autodelete.messagelocation = value;
end

function UpgradeList:DisableAutoDeleteMessageDropdown()
	if UpgradeListDBVar.profile.autodelete.enable and UpgradeListDBVar.profile.autodelete.messages then
		return false
	else
		return true
	end
end

function UpgradeList:IgnoreRingsGet(info)
	return UpgradeListDBVar.profile.ignoreflags.rings;
end

function UpgradeList:IgnoreRingsSet(info, value)
	UpgradeListDBVar.profile.ignoreflags.rings = not UpgradeListDBVar.profile.ignoreflags.rings;
end

function UpgradeList:DisableIgnoreRings()
	if UpgradeListDBVar.profile.autodelete.enable then
		return false
	else
		return true
	end
end

function UpgradeList:IgnoreTrinketsGet(info)
	return UpgradeListDBVar.profile.ignoreflags.trinkets;
end

function UpgradeList:IgnoreTrinketsSet(info, value)
	UpgradeListDBVar.profile.ignoreflags.trinkets = not UpgradeListDBVar.profile.ignoreflags.trinkets;
end

function UpgradeList:DisableIgnoreTrinkets()
	if UpgradeListDBVar.profile.autodelete.enable then
		return false
	else
		return true
	end
end

function UpgradeList:AutoDeleteChoiceDropdownGet(info)
	return UpgradeListDBVar.profile.autodelete.choice;
end

function UpgradeList:AutoDeleteChoiceDropdownSet(info, value)
	UpgradeListDBVar.profile.autodelete.choice = value;
end

function UpgradeList:DisableAutoDeleteChoiceDropdown()
	if UpgradeListDBVar.profile.autodelete.enable then
		return false
	else
		return true
	end
end

function UpgradeList:OneHandWeaponChoiceDropdownGet(info)
	return UpgradeListDBVar.profile.onehandweapon.choice;
end

function UpgradeList:OneHandWeaponChoiceDropdownSet(info, value)
	UpgradeListDBVar.profile.onehandweapon.choice = value;
end

function UpgradeList:ResetDatabase()
	UpgradeListDBVar.char.PrimarySpecList = defaults.char.PrimarySpecList;
	UpgradeListDBVar.char.SecondarySpecList = defaults.char.SecondarySpecList;
end

function UpgradeList:RefreshWindow(name, difficulty, instanceflag)
	local InstanceHighlightColor = {
		["r"] = 0.0,
		["g"] = 0.0,
		["b"] = 0.0,
		["a"] = 1.0,
	};	
	if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() then --If the primary checkbox is checked
		if PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Head.Row, true);
--			if instanceflag == true then
--				local count = 1;
--				while UpgradeListDBVar.char.PrimarySpecList.Head.Row[count] ~= nil do
--					if UpgradeListDBVar.char.PrimarySpecList.Head.Row[count][5] == name and UpgradeListDBVar.char.PrimarySpecList.Head.Row[count][4] == difficulty then
--						--Highlight the particular row
--						--UpgradeListDBVar.char.SavedOptions.tableUL:
--					end
--					count = count + 1;
--				end
--			end
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Back.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Main.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Off.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Other.Row, true);
		end
	else --The secondary checkbox is checked
		if PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Head.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Back.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Main.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Off.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, true);
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16 then
			UpgradeListDBVar.char.SavedOptions.tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Other.Row, true);
		end
	end
	
	
	PanelTemplates_TabResize(Tab_1, 0, 93, 94);
	PanelTemplates_TabResize(Tab_2, 0, 93, 94);
	PanelTemplates_TabResize(Tab_3, 0, 93, 94);
	PanelTemplates_TabResize(Tab_4, 0, 93, 94);
	PanelTemplates_TabResize(Tab_5, 0, 93, 94);
	PanelTemplates_TabResize(Tab_6, 0, 93, 94);
	PanelTemplates_TabResize(Tab_7, 0, 93, 94);
	PanelTemplates_TabResize(Tab_8, 0, 93, 94);
	PanelTemplates_TabResize(Tab_9, 0, 93, 94);
	PanelTemplates_TabResize(Tab_10, 0, 93, 94);
	PanelTemplates_TabResize(Tab_11, 0, 93, 94);
	PanelTemplates_TabResize(Tab_12, 0, 93, 94);
	PanelTemplates_TabResize(Tab_13, 0, 102, 90);
	PanelTemplates_TabResize(Tab_14, 0, 94, 94);
	PanelTemplates_TabResize(Tab_15, 0, 94, 94);
	PanelTemplates_TabResize(Tab_16, 0, 94, 94);
	
	--statusbarfont:SetTextColor(1, 1, 1);
	--statusbarfont:SetText("UpgradeList v " .. UPGRADELIST_VERSION);
end

function UpgradeList:OpenUpgradeList(self)
	UpgradeListMainFrame:Show()
	if UpgradeListDBVar.profile.mainframe.showoptions == false then
		OptionsFrame:Hide()
	end
	UpgradeList:RefreshWindow()
end

function UpgradeList:EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, itemID)
	local priorityfieldnum = tonumber(priorityfield:GetText());
	if priorityfieldnum ~= nil then
		priorityfieldnum = math.floor(priorityfieldnum);
	end
	if itemEquipLoc == "INVTYPE_HEAD" then --Head Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Head.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Head.Row[UpgradeListDBVar.char.PrimarySpecList.Head.Count] = { UpgradeListDBVar.char.PrimarySpecList.Head.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Head.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Head.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Head.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Head.Count = UpgradeListDBVar.char.PrimarySpecList.Head.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Head tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Head.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Head.Row[UpgradeListDBVar.char.SecondarySpecList.Head.Count] = { UpgradeListDBVar.char.SecondarySpecList.Head.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Head.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Head.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Head.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Head.Count = UpgradeListDBVar.char.SecondarySpecList.Head.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Head tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_NECK" then --Neck Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Neck.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Neck.Row[UpgradeListDBVar.char.PrimarySpecList.Neck.Count] = { UpgradeListDBVar.char.PrimarySpecList.Neck.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Neck.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Neck.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Neck.Count = UpgradeListDBVar.char.PrimarySpecList.Neck.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Neck tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Neck.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Neck.Row[UpgradeListDBVar.char.SecondarySpecList.Neck.Count] = { UpgradeListDBVar.char.SecondarySpecList.Neck.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Neck.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Neck.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Neck.Count = UpgradeListDBVar.char.SecondarySpecList.Neck.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Neck tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_SHOULDER" then --Shoulder Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count] = { UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Shoulder tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count] = { UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Shoulder tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_CLOAK" then --Back Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Back.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Back.Row[UpgradeListDBVar.char.PrimarySpecList.Back.Count] = { UpgradeListDBVar.char.PrimarySpecList.Back.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Back.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Back.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Back.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Back.Count = UpgradeListDBVar.char.PrimarySpecList.Back.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Back tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Back.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Back.Row[UpgradeListDBVar.char.SecondarySpecList.Back.Count] = { UpgradeListDBVar.char.SecondarySpecList.Back.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Back.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Back.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Back.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Back.Count = UpgradeListDBVar.char.SecondarySpecList.Back.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Back tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_CHEST" or itemEquipLoc == "INVTYPE_ROBE" then --Chest Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Chest.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Chest.Row[UpgradeListDBVar.char.PrimarySpecList.Chest.Count] = { UpgradeListDBVar.char.PrimarySpecList.Chest.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Chest.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Chest.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Chest.Count = UpgradeListDBVar.char.PrimarySpecList.Chest.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Chest tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Chest.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Chest.Row[UpgradeListDBVar.char.SecondarySpecList.Chest.Count] = { UpgradeListDBVar.char.SecondarySpecList.Chest.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Chest.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Chest.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Chest.Count = UpgradeListDBVar.char.SecondarySpecList.Chest.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Chest tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_WRIST" then --Wrist Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Wrist.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[UpgradeListDBVar.char.PrimarySpecList.Wrist.Count] = { UpgradeListDBVar.char.PrimarySpecList.Wrist.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Wrist.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Wrist.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Wrist.Count = UpgradeListDBVar.char.PrimarySpecList.Wrist.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Wrist tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Wrist.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[UpgradeListDBVar.char.SecondarySpecList.Wrist.Count] = { UpgradeListDBVar.char.SecondarySpecList.Wrist.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Wrist.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Wrist.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Wrist.Count = UpgradeListDBVar.char.SecondarySpecList.Wrist.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Wrist tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_HAND" then --Hand Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Hand.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Hand.Row[UpgradeListDBVar.char.PrimarySpecList.Hand.Count] = { UpgradeListDBVar.char.PrimarySpecList.Hand.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Hand.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Hand.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Hand.Count = UpgradeListDBVar.char.PrimarySpecList.Hand.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Hand tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Hand.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Hand.Row[UpgradeListDBVar.char.SecondarySpecList.Hand.Count] = { UpgradeListDBVar.char.SecondarySpecList.Hand.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Hand.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Hand.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Hand.Count = UpgradeListDBVar.char.SecondarySpecList.Hand.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Hand tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_WAIST" then --Waist Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Waist.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Waist.Row[UpgradeListDBVar.char.PrimarySpecList.Waist.Count] = { UpgradeListDBVar.char.PrimarySpecList.Waist.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Waist.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Waist.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Waist.Count = UpgradeListDBVar.char.PrimarySpecList.Waist.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Waist tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Waist.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Waist.Row[UpgradeListDBVar.char.SecondarySpecList.Waist.Count] = { UpgradeListDBVar.char.SecondarySpecList.Waist.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Waist.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Waist.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Waist.Count = UpgradeListDBVar.char.SecondarySpecList.Waist.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Waist tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_LEGS" then --Leg Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Leg.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Leg.Row[UpgradeListDBVar.char.PrimarySpecList.Leg.Count] = { UpgradeListDBVar.char.PrimarySpecList.Leg.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Leg.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Leg.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Leg.Count = UpgradeListDBVar.char.PrimarySpecList.Leg.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Leg tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Leg.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Leg.Row[UpgradeListDBVar.char.SecondarySpecList.Leg.Count] = { UpgradeListDBVar.char.SecondarySpecList.Leg.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Leg.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Leg.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Leg.Count = UpgradeListDBVar.char.SecondarySpecList.Leg.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Leg tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_FEET" then --Foot Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Foot.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Foot.Row[UpgradeListDBVar.char.PrimarySpecList.Foot.Count] = { UpgradeListDBVar.char.PrimarySpecList.Foot.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Foot.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Foot.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Foot.Count = UpgradeListDBVar.char.PrimarySpecList.Foot.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Foot tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Foot.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Foot.Row[UpgradeListDBVar.char.SecondarySpecList.Foot.Count] = { UpgradeListDBVar.char.SecondarySpecList.Foot.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Foot.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Foot.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Foot.Count = UpgradeListDBVar.char.SecondarySpecList.Foot.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Foot tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_FINGER" then --Rings
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Ring.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Ring.Row[UpgradeListDBVar.char.PrimarySpecList.Ring.Count] = { UpgradeListDBVar.char.PrimarySpecList.Ring.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Ring.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Ring.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Ring.Count = UpgradeListDBVar.char.PrimarySpecList.Ring.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Ring tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Ring.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Ring.Row[UpgradeListDBVar.char.SecondarySpecList.Ring.Count] = { UpgradeListDBVar.char.SecondarySpecList.Ring.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Ring.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Ring.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Ring.Count = UpgradeListDBVar.char.SecondarySpecList.Ring.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Ring tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_TRINKET" then --Trinkets
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Trinket.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[UpgradeListDBVar.char.PrimarySpecList.Trinket.Count] = { UpgradeListDBVar.char.PrimarySpecList.Trinket.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Trinket.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Trinket.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Trinket.Count = UpgradeListDBVar.char.PrimarySpecList.Trinket.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Trinket tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Trinket.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[UpgradeListDBVar.char.SecondarySpecList.Trinket.Count] = { UpgradeListDBVar.char.SecondarySpecList.Trinket.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Trinket.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Trinket.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Trinket.Count = UpgradeListDBVar.char.SecondarySpecList.Trinket.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Trinket tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_WEAPONMAINHAND" or itemEquipLoc == "INVTYPE_2HWEAPON" then --Main Hand Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Main.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Main.Row[UpgradeListDBVar.char.PrimarySpecList.Main.Count] = { UpgradeListDBVar.char.PrimarySpecList.Main.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Main.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Main.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Main.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Main.Count = UpgradeListDBVar.char.PrimarySpecList.Main.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Main tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Main.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Main.Row[UpgradeListDBVar.char.SecondarySpecList.Main.Count] = { UpgradeListDBVar.char.SecondarySpecList.Main.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Main.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Main.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Main.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Main.Count = UpgradeListDBVar.char.SecondarySpecList.Main.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Main tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_WEAPONOFFHAND" or itemEquipLoc == "INVTYPE_SHIELD" or itemEquipLoc == "INVTYPE_HOLDABLE" then --Off Hand Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Off.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Off.Row[UpgradeListDBVar.char.PrimarySpecList.Off.Count] = { UpgradeListDBVar.char.PrimarySpecList.Off.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Off.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Off.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Off.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Off.Count = UpgradeListDBVar.char.PrimarySpecList.Off.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Off tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Off.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Off.Row[UpgradeListDBVar.char.SecondarySpecList.Off.Count] = { UpgradeListDBVar.char.SecondarySpecList.Off.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Off.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Off.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Off.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Off.Count = UpgradeListDBVar.char.SecondarySpecList.Off.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Off tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_RANGED" or itemEquipLoc == "INVTYPE_THROWN" or itemEquipLoc == "INVTYPE_RANGEDRIGHT" or itemEquipLoc == "INVTYPE_RELIC" then --Ranged Slot Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Ranged.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[UpgradeListDBVar.char.PrimarySpecList.Ranged.Count] = { UpgradeListDBVar.char.PrimarySpecList.Ranged.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Ranged.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Ranged.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Ranged.Count = UpgradeListDBVar.char.PrimarySpecList.Ranged.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Ranged tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Ranged.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[UpgradeListDBVar.char.SecondarySpecList.Ranged.Count] = { UpgradeListDBVar.char.SecondarySpecList.Ranged.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Ranged.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Ranged.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Ranged.Count = UpgradeListDBVar.char.SecondarySpecList.Ranged.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Ranged tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_WEAPON" then --Main Hand OR Off Hand Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		else
			WeaponInput:Show(); --After checking that priority field is a number and an item location is selected, show the WeaponInput frame.
			UpgradeListMainFrame:EnableMouse(false)
			CloseButton:EnableMouse(false)
			ToggleButton:EnableMouse(false)
			UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(false)
			UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(false)
			OptionsFrame:EnableMouse(false)
			ItemEntryBox:EnableMouse(false)
			DropDown_Button:EnableMouse(false)
			NoteEntryBox:EnableMouse(false)
			PrimarySpecRadioButton:EnableMouse(false)
			SecondarySpecRadioButton:EnableMouse(false)
			priorityfield:EnableMouse(false)
			AddButton:EnableMouse(false)
			tofield:EnableMouse(false)
			fromfield:EnableMouse(false)
			MoveButton:EnableMouse(false)
			DeleteButton:EnableMouse(false)
			deletefield:EnableMouse(false)
		end
	else --Adding to Other tab.
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UpgradeListDBVar.char.SavedOptions.SelectedInstance == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Other.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Other.Row[UpgradeListDBVar.char.PrimarySpecList.Other.Count] = { UpgradeListDBVar.char.PrimarySpecList.Other.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Other.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Other.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.PrimarySpecList.Other.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Other.Count = UpgradeListDBVar.char.PrimarySpecList.Other.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Other tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16) and (UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Other.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Other.Row[UpgradeListDBVar.char.SecondarySpecList.Other.Count] = { UpgradeListDBVar.char.SecondarySpecList.Other.Count, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Other.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Other.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeListDBVar.char.SavedOptions.SelectedDifficulty, UpgradeListDBVar.char.SavedOptions.SelectedInstance, UpgradeListDBVar.char.SavedOptions.SelectedBoss, NoteEntryBox:GetText(), itemID });
				for i = UpgradeListDBVar.char.SecondarySpecList.Other.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Other.Count = UpgradeListDBVar.char.SecondarySpecList.Other.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Other tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16) and (UpgradeListDBVar.char.SavedOptions.SecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
				UpgradeList:RefreshWindow()
			end
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = nil;
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	end
end

function UpgradeList:AddItem(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox)
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(ItemEntryBox:GetText());
	local ID, Color, Ltype;
	if itemEquipLoc ~= nil then
		_, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
	end
	if itemEquipLoc == "" or itemEquipLoc == "INVTYPE_BAG" or itemEquipLoc == "INVTYPE_TABARD" or itemEqupLoc == "BODY" then --Non-equipable items
		UpgradeList:EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
	elseif itemEquipLoc == nil then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("Invalid item.");
		ItemEntryBox:HighlightText();
	else
		local localizedClass, englishClass = UnitClass("player");
		if englishClass == "DEATHKNIGHT" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Mail") and (itemSubType ~= "Plate") and (itemSubType ~= "Relic") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "Two-Handed Maces") and (itemSubType ~= "Polearms") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Two-Handed Swords") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "Two-Handed Axes") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				UpgradeList:EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "DRUID" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Relic") and (itemSubType ~= "Daggers") and (itemSubType ~= "Fist Weapons") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "Polearms") and (itemSubType ~= "Staves") and (itemSubType ~= "Two-Handed Maces") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				UpgradeList:EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "HUNTER" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Mail") and (itemSubType ~= "Guns") and (itemSubType ~= "Bows") and (itemSubType ~= "Crossbows") and (itemSubType ~= "Thrown") and (itemSubType ~= "Fist Weapons") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Polearms") and (itemSubType ~= "Staves") and (itemSubType ~= "Two-Handed Axes") and (itemSubType ~= "Two-Handed Swords") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				UpgradeList:EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "MAGE" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Staves") and (itemSubType ~= "Wands") and (itemSubType ~= "Daggers") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				UpgradeList:EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "PALADIN" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Mail") and (itemSubType ~= "Plate") and (itemSubType ~= "Shields") and (itemSubType ~= "Relic") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "Two-Handed Maces") and (itemSubType ~= "Polearms") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Two-Handed Swords") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "Two-Handed Axes") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				UpgradeList:EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "PRIEST" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Staves") and (itemSubType ~= "Wands") and (itemSubType ~= "Daggers") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				UpgradeList:EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "ROGUE" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Daggers") and (itemSubType ~= "Fist Weapons") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Bows") and (itemSubType ~= "Crossbows") and (itemSubType ~= "Thrown") and (itemSubType ~= "Guns") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				UpgradeList:EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "SHAMAN" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Mail") and (itemSubType ~= "Shields") and (itemSubType ~= "Daggers") and (itemSubType ~= "Fist Weapons") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "Relic") and (itemSubType ~= "Staves") and (itemSubType ~= "Two-Handed Maces") and (itemSubType ~= "Two-Handed Axes") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				UpgradeList:EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "WARLOCK" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Staves") and (itemSubType ~= "Wands") and (itemSubType ~= "Daggers") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				UpgradeList:EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		elseif englishClass == "WARRIOR" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Mail") and (itemSubType ~= "Plate") and (itemSubType ~= "Shields") and (itemSubType ~= "Bows") and (itemSubType ~= "Crossbows") and (itemSubType ~= "Fist Weapons") and (itemSubType ~= "Guns") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Polearms") and (itemSubType ~= "Staves") and (itemSubType ~= "Two-Handed Axes") and (itemSubType ~= "Two-Handed Maces") and (itemSubType ~= "Two-Handed Swords") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the equipable item
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else 
				--Player can equip the item
				UpgradeList:EnterItemIntoDatabase(ItemEntryBox, PrimarySpecRadioButton, SecondarySpecRadioButton, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice, ID)
			end
		else
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("ERROR: Unable to determine your class.");
		end
	end
end

function UpgradeList:DeleteItem(deletefield, UpgradeListMainFrame, statusbarfont)
	local deletefieldnum = tonumber(deletefield:GetText());
	if deletefieldnum ~= nil then
		deletefieldnum = math.floor(deletefieldnum);
	end
	if deletefieldnum == nil and deletefield:GetText() ~= "" then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("Delete field must be a number.");
		deletefield:HighlightText();
	elseif deletefieldnum == nil then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("Nothing entered in delete field.");
		deletefield:HighlightText();
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1 then --If the head tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Head.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Head list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Head.Count - 1 and deletefieldnum > 0 then --If deleted item is NOT the last one in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Head.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Head.Count = UpgradeListDBVar.char.PrimarySpecList.Head.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Head list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Head.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Head.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Head.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			elseif deletefieldnum > 0 then --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Head.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Head.Count = UpgradeListDBVar.char.PrimarySpecList.Head.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Head list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText(deletefieldnum .. " is not a valid number for deletion.");
				deletefield:HighlightText();
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Head.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Head list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Head.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Head.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Head.Count = UpgradeListDBVar.char.SecondarySpecList.Head.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Head list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Head.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Head.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Head.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Head.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Head.Count = UpgradeListDBVar.char.SecondarySpecList.Head.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Head list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2 then --If the neck tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Neck.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Neck list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Neck.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Neck.Count = UpgradeListDBVar.char.PrimarySpecList.Neck.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Neck list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Neck.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Neck.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Neck.Count = UpgradeListDBVar.char.PrimarySpecList.Neck.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Neck list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Neck.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Neck list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Neck.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Neck.Count = UpgradeListDBVar.char.SecondarySpecList.Neck.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Neck list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Neck.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Neck.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Neck.Count = UpgradeListDBVar.char.SecondarySpecList.Neck.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Neck list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3 then --If the Shoulder tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Shoulder list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Shoulder list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Shoulder list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Shoulder list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Shoulder list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Shoulder list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4 then --If the Back tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Back.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Back list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Back.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Back.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Back.Count = UpgradeListDBVar.char.PrimarySpecList.Back.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Back list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Back.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Back.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Back.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Back.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Back.Count = UpgradeListDBVar.char.PrimarySpecList.Back.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Back list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Back.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Back list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Back.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Back.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Back.Count = UpgradeListDBVar.char.SecondarySpecList.Back.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Back list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Back.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Back.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Back.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Back.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Back.Count = UpgradeListDBVar.char.SecondarySpecList.Back.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Back list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5 then --If the Chest tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Chest.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Chest list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Chest.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Chest.Count = UpgradeListDBVar.char.PrimarySpecList.Chest.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Chest list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Chest.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Chest.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Chest.Count = UpgradeListDBVar.char.PrimarySpecList.Chest.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Chest list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Chest.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Chest list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Chest.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Chest.Count = UpgradeListDBVar.char.SecondarySpecList.Chest.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Chest list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Chest.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Chest.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Chest.Count = UpgradeListDBVar.char.SecondarySpecList.Chest.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Chest list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6 then --If the Wrist tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Wrist.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Wrist list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Wrist.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Wrist.Count = UpgradeListDBVar.char.PrimarySpecList.Wrist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Wrist list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Wrist.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Wrist.Count = UpgradeListDBVar.char.PrimarySpecList.Wrist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Wrist list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Wrist.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Wrist list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Wrist.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Wrist.Count = UpgradeListDBVar.char.SecondarySpecList.Wrist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Wrist list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Wrist.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Wrist.Count = UpgradeListDBVar.char.SecondarySpecList.Wrist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Wrist list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7 then --If the Hand tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Hand.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Hand list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Hand.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Hand.Count = UpgradeListDBVar.char.PrimarySpecList.Hand.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Hand list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Hand.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Hand.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Hand.Count = UpgradeListDBVar.char.PrimarySpecList.Hand.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Hand.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Hand list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Hand.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Hand.Count = UpgradeListDBVar.char.SecondarySpecList.Hand.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Hand list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Hand.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Hand.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Hand.Count = UpgradeListDBVar.char.SecondarySpecList.Hand.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8 then --If the Waist tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Waist.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Waist list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Waist.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Waist.Count = UpgradeListDBVar.char.PrimarySpecList.Waist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Waist list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Waist.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Waist.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Waist.Count = UpgradeListDBVar.char.PrimarySpecList.Waist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Waist list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Waist.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Waist list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Waist.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Waist.Count = UpgradeListDBVar.char.SecondarySpecList.Waist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Waist list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Waist.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Waist.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Waist.Count = UpgradeListDBVar.char.SecondarySpecList.Waist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Waist list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9 then --If the Leg tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Leg.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Leg list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Leg.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Leg.Count = UpgradeListDBVar.char.PrimarySpecList.Leg.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Leg list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Leg.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Leg.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Leg.Count = UpgradeListDBVar.char.PrimarySpecList.Leg.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Leg list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Leg.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Leg list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Leg.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Leg.Count = UpgradeListDBVar.char.SecondarySpecList.Leg.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Leg list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Leg.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Leg.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Leg.Count = UpgradeListDBVar.char.SecondarySpecList.Leg.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Leg list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10 then --If the Foot tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Foot.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Foot list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Foot.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Foot.Count = UpgradeListDBVar.char.PrimarySpecList.Foot.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Foot list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Foot.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Foot.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Foot.Count = UpgradeListDBVar.char.PrimarySpecList.Foot.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Foot list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Foot.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Foot list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Foot.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Foot.Count = UpgradeListDBVar.char.SecondarySpecList.Foot.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Foot list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Foot.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Foot.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Foot.Count = UpgradeListDBVar.char.SecondarySpecList.Foot.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Foot list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11 then --If the Ring tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ring.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Ring list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Ring.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Ring.Count = UpgradeListDBVar.char.PrimarySpecList.Ring.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Ring list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Ring.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Ring.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Ring.Count = UpgradeListDBVar.char.PrimarySpecList.Ring.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Ring list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ring.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Ring list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Ring.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Ring.Count = UpgradeListDBVar.char.SecondarySpecList.Ring.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Ring list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Ring.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Ring.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Ring.Count = UpgradeListDBVar.char.SecondarySpecList.Ring.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Ring list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12 then --If the Trinket tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Trinket.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Trinket list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Trinket.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Trinket.Count = UpgradeListDBVar.char.PrimarySpecList.Trinket.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Trinket list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Trinket.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Trinket.Count = UpgradeListDBVar.char.PrimarySpecList.Trinket.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Trinket list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Trinket.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Trinket list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Trinket.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Trinket.Count = UpgradeListDBVar.char.SecondarySpecList.Trinket.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Trinket list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Trinket.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Trinket.Count = UpgradeListDBVar.char.SecondarySpecList.Trinket.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Trinket list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13 then --If the Main tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Main.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Main list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Main.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Main.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Main.Count = UpgradeListDBVar.char.PrimarySpecList.Main.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Main Hand list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Main.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Main.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Main.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Main.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Main.Count = UpgradeListDBVar.char.PrimarySpecList.Main.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Main Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Main.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Main list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Main.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Main.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Main.Count = UpgradeListDBVar.char.SecondarySpecList.Main.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Main Hand list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Main.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Main.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Main.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Main.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Main.Count = UpgradeListDBVar.char.SecondarySpecList.Main.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Main Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14 then --If the Off tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Off.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Off list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Off.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Off.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Off.Count = UpgradeListDBVar.char.PrimarySpecList.Off.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Off Hand list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Off.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Off.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Off.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Off.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Off.Count = UpgradeListDBVar.char.PrimarySpecList.Off.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Off Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Off.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Off list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Off.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Off.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Off.Count = UpgradeListDBVar.char.SecondarySpecList.Off.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Off Hand list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Off.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Off.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Off.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Off.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Off.Count = UpgradeListDBVar.char.SecondarySpecList.Off.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Off Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15 then --If the Ranged tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ranged.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Ranged list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Ranged.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Ranged.Count = UpgradeListDBVar.char.PrimarySpecList.Ranged.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Ranged list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Ranged.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Ranged.Count = UpgradeListDBVar.char.PrimarySpecList.Ranged.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Ranged list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ranged.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Ranged list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Ranged.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Ranged.Count = UpgradeListDBVar.char.SecondarySpecList.Ranged.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Ranged list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Ranged.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Ranged.Count = UpgradeListDBVar.char.SecondarySpecList.Ranged.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Ranged list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16 then --If the Other tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Other.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Other list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Other.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Other.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Other.Count = UpgradeListDBVar.char.PrimarySpecList.Other.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Other list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Other.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Other.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Other.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Other.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Other.Count = UpgradeListDBVar.char.PrimarySpecList.Other.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Other list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Other.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Other list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Other.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Other.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Other.Count = UpgradeListDBVar.char.SecondarySpecList.Other.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Other list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Other.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Other.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Other.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Other.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Other.Count = UpgradeListDBVar.char.SecondarySpecList.Other.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Other list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	else
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText(deletefield:GetText() .. " is not a valid number for the delete number.");
	end
end

function UpgradeList:MoveItem(fromfield, tofield, UpgradeListMainFrame)
	local fromfieldnum = tonumber(fromfield:GetText());
	local tofieldnum = tonumber(tofield:GetText());
	if fromfieldnum ~= nil and tofieldnum ~= nil then
		fromfieldnum = math.floor(fromfieldnum);
		tofieldnum = math.floor(tofieldnum);
	end
	if fromfieldnum == nil and fromfield:GetText() ~= "" then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("From field must be a number.");
		fromfield:HighlightText();
	elseif tofieldnum == nil and tofield:GetText() ~= "" then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("To field must be a number.");
		tofield:HighlightText();
	elseif fromfieldnum == nil then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("Nothing entered in from field.");
		fromfield:HighlightText();
	elseif tofieldnum == nil then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("Nothing entered in to field.");
		tofield:HighlightText();
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1 then --If the head tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Head.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Head list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Head.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Head list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Head.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Head.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Head.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Head.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Head.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Head.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Head.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Head.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Head list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Head.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Head list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Head.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Head list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Head.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Head.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Head.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Head.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Head.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Head.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Head.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Head.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Head list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2 then --If the Neck tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Neck.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Neck list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Neck.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Neck list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Neck.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Neck.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Neck.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Neck.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Neck list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Neck.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Neck list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Neck.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Neck list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Neck.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Neck.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Neck.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Neck.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Neck list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3 then --If the Shoulder tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Shoulder list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Shoulder list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Shoulder list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Shoulder list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Shoulder list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Shoulder list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4 then --If the Back tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Back.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Back list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Back.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Back list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Back.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Back.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Back.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Back.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Back.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Back.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Back.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Back.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Back list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Back.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Back list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Back.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Back list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Back.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Back.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Back.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Back.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Back.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Back.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Back.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Back.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Back list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5 then --If the Chest tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Chest.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Chest list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Chest.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Chest list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Chest.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Chest.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Chest.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Chest.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Chest list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Chest.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Chest list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Chest.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Chest list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Chest.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Chest.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Chest.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Chest.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Chest list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6 then --If the Wrist tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Wrist.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Wrist list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Wrist.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Wrist list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Wrist list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Wrist.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Wrist list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Wrist.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Wrist list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Wrist list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7 then --If the Hand tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Hand.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Hand list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Hand.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Hand list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Hand.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Hand.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Hand.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Hand.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Hand list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Hand.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Hand list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Hand.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Hand list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Hand.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Hand.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Hand.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Hand.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Hand list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8 then --If the Waist tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Waist.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Waist list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Waist.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Waist list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Waist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Waist.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Waist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Waist.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Waist list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Waist.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Waist list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Waist.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Waist list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Waist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Waist.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Waist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Waist.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Waist list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9 then --If the Leg tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Leg.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Leg list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Leg.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Leg list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Leg.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Leg.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Leg.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Leg.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Leg list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Leg.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Leg list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Leg.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Leg list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Leg.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Leg.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Leg.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Leg.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Leg list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10 then --If the Foot tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Foot.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Foot list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Foot.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Foot list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Foot.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Foot.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Foot.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Foot.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Foot list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Foot.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Foot list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Foot.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Foot list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Foot.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Foot.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Foot.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Foot.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Foot list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11 then --If the Ring tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ring.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Ring list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ring.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Ring list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Ring.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Ring.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Ring.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Ring.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Ring list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ring.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Ring list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ring.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Ring list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Ring.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Ring.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Ring.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Ring.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Ring list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12 then --If the Trinket tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Trinket.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Trinket list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Trinket.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Trinket list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Trinket list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Trinket.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Trinket list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Trinket.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Trinket list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Trinket list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13 then --If the Main tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Main.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Main list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Main.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Main list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Main.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Main.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Main.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Main.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Main.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Main.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Main.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Main.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Main list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Main.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Main list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Main.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Main list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Main.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Main.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Main.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Main.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Main.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Main.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Main.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Main.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Main list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14 then --If the Off tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Off.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Off list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Off.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Off list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Off.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Off.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Off.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Off.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Off.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Off.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Off.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Off.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Off list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Off.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Off list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Off.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Off list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Off.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Off.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Off.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Off.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Off.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Off.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Off.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Off.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Off list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15 then --If the Ranged tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ranged.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Ranged list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ranged.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Ranged list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Ranged list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ranged.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Ranged list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ranged.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Ranged list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Ranged list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16 then --If the Other tab is selected
		if UpgradeListDBVar.char.SavedOptions.PrimaryCheck:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Other.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Other list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Other.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Other list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Other.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Other.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Other.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Other.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Other.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Other.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Other.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Other.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Other list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Other.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Other list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Other.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Other list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Other.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Other.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Other.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Other.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Other.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Other.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Other.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Other.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Other list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				UpgradeList:RefreshWindow()
			end
		end
	else
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("ERROR: Unable to determine selected tab.");
	end
end

function UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, spec, onehandweaponslot) --spec can be "mainspec" or "offspec" | onehandweaponslot can be "mainhand" or "offhand"
	if spec == "mainspec" then --Main Spec items
		if onehandweaponslot == "mainhand" then --Main Spec Main Hand 1-handed weapons
			local rownum = 0;
			repeat
				rownum = rownum + 1;
			until (UpgradeListDBVar.char.PrimarySpecList.Main.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Main.Row[rownum] == nil);
			if UpgradeListDBVar.profile.autodelete.messages then
				if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
					DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[rownum][3] .. " from your Primary Spec's Main Hand list.");
				elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
					UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[rownum][3] .. " from your Primary Spec's Main Hand list.");
				end
			end
			for i = #UpgradeListDBVar.char.PrimarySpecList.Main.Row, rownum, -1 do
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Main.Row);
				UpgradeListDBVar.char.PrimarySpecList.Main.Count = UpgradeListDBVar.char.PrimarySpecList.Main.Count - 1;
			end
		elseif onehandweaponslot == "offhand" then --Main Spec Off Hand 1-handed weapons
			local rownum = 0;
			repeat
				rownum = rownum + 1;
			until (UpgradeListDBVar.char.PrimarySpecList.Off.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Off.Row[rownum] == nil);
			if UpgradeListDBVar.profile.autodelete.messages then
				if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
					DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[rownum][3] .. " from your Primary Spec's Off Hand list.");
				elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
					UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[rownum][3] .. " from your Primary Spec's Off Hand list.");
				end
			end
			for i = #UpgradeListDBVar.char.PrimarySpecList.Off.Row, rownum, -1 do
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Off.Row);
				UpgradeListDBVar.char.PrimarySpecList.Off.Count = UpgradeListDBVar.char.PrimarySpecList.Off.Count - 1;
			end
		else --Main Spec non 1-handed items
			if itemEquipLocation == "INVTYPE_HEAD" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Head.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Head.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Head.Row[rownum][3] .. " from your Primary Spec's Head list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Head.Row[rownum][3] .. " from your Primary Spec's Head list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Head.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Head.Row);
					UpgradeListDBVar.char.PrimarySpecList.Head.Count = UpgradeListDBVar.char.PrimarySpecList.Head.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_NECK" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Neck.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Neck.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Neck.Row[rownum][3] .. " from your Primary Spec's Neck list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Neck.Row[rownum][3] .. " from your Primary Spec's Neck list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Neck.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Neck.Row);
					UpgradeListDBVar.char.PrimarySpecList.Neck.Count = UpgradeListDBVar.char.PrimarySpecList.Neck.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_SHOULDER" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[rownum][3] .. " from your Primary Spec's Shoulder list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[rownum][3] .. " from your Primary Spec's Shoulder list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row);
					UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_CLOAK" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Back.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Back.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Back.Row[rownum][3] .. " from your Primary Spec's Back list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Back.Row[rownum][3] .. " from your Primary Spec's Back list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Back.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Back.Row);
					UpgradeListDBVar.char.PrimarySpecList.Back.Count = UpgradeListDBVar.char.PrimarySpecList.Back.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_CHEST" or itemEquipLocation == "INVTYPE_ROBE" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Chest.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Chest.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Chest.Row[rownum][3] .. " from your Primary Spec's Chest list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Chest.Row[rownum][3] .. " from your Primary Spec's Chest list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Chest.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Chest.Row);
					UpgradeListDBVar.char.PrimarySpecList.Chest.Count = UpgradeListDBVar.char.PrimarySpecList.Chest.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_WRIST" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[rownum][3] .. " from your Primary Spec's Wrist list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[rownum][3] .. " from your Primary Spec's Wrist list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row);
					UpgradeListDBVar.char.PrimarySpecList.Wrist.Count = UpgradeListDBVar.char.PrimarySpecList.Wrist.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_HAND" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Hand.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Hand.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Hand.Row[rownum][3] .. " from your Primary Spec's Hand list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Hand.Row[rownum][3] .. " from your Primary Spec's Hand list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Hand.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Hand.Row);
					UpgradeListDBVar.char.PrimarySpecList.Hand.Count = UpgradeListDBVar.char.PrimarySpecList.Hand.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_WAIST" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Waist.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Waist.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Waist.Row[rownum][3] .. " from your Primary Spec's Waist list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Waist.Row[rownum][3] .. " from your Primary Spec's Waist list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Waist.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Waist.Row);
					UpgradeListDBVar.char.PrimarySpecList.Waist.Count = UpgradeListDBVar.char.PrimarySpecList.Waist.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_LEGS" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Leg.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Leg.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Leg.Row[rownum][3] .. " from your Primary Spec's Leg list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Leg.Row[rownum][3] .. " from your Primary Spec's Leg list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Leg.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Leg.Row);
					UpgradeListDBVar.char.PrimarySpecList.Leg.Count = UpgradeListDBVar.char.PrimarySpecList.Leg.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_FEET" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Foot.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Foot.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Foot.Row[rownum][3] .. " from your Primary Spec's Foot list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Foot.Row[rownum][3] .. " from your Primary Spec's Foot list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Foot.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Foot.Row);
					UpgradeListDBVar.char.PrimarySpecList.Foot.Count = UpgradeListDBVar.char.PrimarySpecList.Foot.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_FINGER" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Ring.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Ring.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Ring.Row[rownum][3] .. " from your Primary Spec's Finger list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Ring.Row[rownum][3] .. " from your Primary Spec's Finger list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Ring.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Ring.Row);
					UpgradeListDBVar.char.PrimarySpecList.Ring.Count = UpgradeListDBVar.char.PrimarySpecList.Ring.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_TRINKET" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[rownum][3] .. " from your Primary Spec's Trinket list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[rownum][3] .. " from your Primary Spec's Trinket list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row);
					UpgradeListDBVar.char.PrimarySpecList.Trinket.Count = UpgradeListDBVar.char.PrimarySpecList.Trinket.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_WEAPONMAINHAND" or itemEquipLocation == "INVTYPE_2HWEAPON" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Main.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Main.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[rownum][3] .. " from your Primary Spec's Main Hand list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[rownum][3] .. " from your Primary Spec's Main Hand list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Main.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Main.Row);
					UpgradeListDBVar.char.PrimarySpecList.Main.Count = UpgradeListDBVar.char.PrimarySpecList.Main.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_WEAPONOFFHAND" or itemEquipLocation == "INVTYPE_SHIELD" or itemEquipLocation == "INVTYPE_HOLDABLE" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Off.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Off.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[rownum][3] .. " from your Primary Spec's Off Hand list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[rownum][3] .. " from your Primary Spec's Off Hand list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Off.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Off.Row);
					UpgradeListDBVar.char.PrimarySpecList.Off.Count = UpgradeListDBVar.char.PrimarySpecList.Off.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_RANGED" or itemEquipLocation == "INVTYPE_THROWN" or itemEquipLocation == "INVTYPE_RANGEDRIGHT" or itemEquipLocation == "INVTYPE_RELIC" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[rownum][8] == itemID or UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[rownum][3] .. " from your Primary Spec's Ranged list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[rownum][3] .. " from your Primary Spec's Ranged list.");
					end
				end
				for i = #UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row);
					UpgradeListDBVar.char.PrimarySpecList.Ranged.Count = UpgradeListDBVar.char.PrimarySpecList.Ranged.Count - 1;
				end
			end
		end
	else --Off Spec items
		if onehandweaponslot == "mainhand" then --Off Spec Main Hand 1-handed weapons
			local rownum = 0;
			repeat
				rownum = rownum + 1;
			until (UpgradeListDBVar.char.SecondarySpecList.Main.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Main.Row[rownum] == nil);
			if UpgradeListDBVar.profile.autodelete.messages then
				if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
					DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[rownum][3] .. " from your Secondary Spec's Main Hand list.");
				elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
					UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[rownum][3] .. " from your Secondary Spec's Main Hand list.");
				end
			end
			for i = #UpgradeListDBVar.char.SecondarySpecList.Main.Row, rownum, -1 do
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Main.Row);
				UpgradeListDBVar.char.SecondarySpecList.Main.Count = UpgradeListDBVar.char.SecondarySpecList.Main.Count - 1;
			end
		elseif onehandweaponslot == "offhand" then --Off Spec Off Hand 1-handed weapons
			local rownum = 0;
			repeat
				rownum = rownum + 1;
			until (UpgradeListDBVar.char.SecondarySpecList.Off.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Off.Row[rownum] == nil);
			if UpgradeListDBVar.profile.autodelete.messages then
				if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
					DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[rownum][3] .. " from your Secondary Spec's Off Hand list.");
				elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
					UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[rownum][3] .. " from your Secondary Spec's Off Hand list.");
				end
			end
			for i = #UpgradeListDBVar.char.SecondarySpecList.Off.Row, rownum, -1 do
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Off.Row);
				UpgradeListDBVar.char.SecondarySpecList.Off.Count = UpgradeListDBVar.char.SecondarySpecList.Off.Count - 1;
			end
		else --Off Spec non 1-handed items
			if itemEquipLocation == "INVTYPE_HEAD" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Head.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Head.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Head.Row[rownum][3] .. " from your Secondary Spec's Head list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Head.Row[rownum][3] .. " from your Secondary Spec's Head list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Head.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Head.Row);
					UpgradeListDBVar.char.SecondarySpecList.Head.Count = UpgradeListDBVar.char.SecondarySpecList.Head.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_NECK" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Neck.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Neck.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Neck.Row[rownum][3] .. " from your Secondary Spec's Neck list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Neck.Row[rownum][3] .. " from your Secondary Spec's Neck list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Neck.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Neck.Row);
					UpgradeListDBVar.char.SecondarySpecList.Neck.Count = UpgradeListDBVar.char.SecondarySpecList.Neck.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_SHOULDER" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[rownum][3] .. " from your Secondary Spec's Shoulder list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[rownum][3] .. " from your Secondary Spec's Shoulder list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row);
					UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_CLOAK" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Back.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Back.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Back.Row[rownum][3] .. " from your Secondary Spec's Back list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Back.Row[rownum][3] .. " from your Secondary Spec's Back list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Back.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Back.Row);
					UpgradeListDBVar.char.SecondarySpecList.Back.Count = UpgradeListDBVar.char.SecondarySpecList.Back.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_CHEST" or itemEquipLocation == "INVTYPE_ROBE" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Chest.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Chest.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Chest.Row[rownum][3] .. " from your Secondary Spec's Chest list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Chest.Row[rownum][3] .. " from your Secondary Spec's Chest list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Chest.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Chest.Row);
					UpgradeListDBVar.char.SecondarySpecList.Chest.Count = UpgradeListDBVar.char.SecondarySpecList.Chest.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_WRIST" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[rownum][3] .. " from your Secondary Spec's Wrist list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[rownum][3] .. " from your Secondary Spec's Wrist list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row);
					UpgradeListDBVar.char.SecondarySpecList.Wrist.Count = UpgradeListDBVar.char.SecondarySpecList.Wrist.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_HAND" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Hand.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Hand.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Hand.Row[rownum][3] .. " from your Secondary Spec's Hand list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Hand.Row[rownum][3] .. " from your Secondary Spec's Hand list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Hand.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Hand.Row);
					UpgradeListDBVar.char.SecondarySpecList.Hand.Count = UpgradeListDBVar.char.SecondarySpecList.Hand.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_WAIST" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Waist.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Waist.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Waist.Row[rownum][3] .. " from your Secondary Spec's Waist list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Waist.Row[rownum][3] .. " from your Secondary Spec's Waist list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Waist.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Waist.Row);
					UpgradeListDBVar.char.SecondarySpecList.Waist.Count = UpgradeListDBVar.char.SecondarySpecList.Waist.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_LEGS" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Leg.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Leg.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Leg.Row[rownum][3] .. " from your Secondary Spec's Leg list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Leg.Row[rownum][3] .. " from your Secondary Spec's Leg list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Leg.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Leg.Row);
					UpgradeListDBVar.char.SecondarySpecList.Leg.Count = UpgradeListDBVar.char.SecondarySpecList.Leg.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_FEET" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Foot.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Foot.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Foot.Row[rownum][3] .. " from your Secondary Spec's Foot list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Foot.Row[rownum][3] .. " from your Secondary Spec's Foot list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Foot.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Foot.Row);
					UpgradeListDBVar.char.SecondarySpecList.Foot.Count = UpgradeListDBVar.char.SecondarySpecList.Foot.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_FINGER" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Ring.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Ring.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Ring.Row[rownum][3] .. " from your Secondary Spec's Finger list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Ring.Row[rownum][3] .. " from your Secondary Spec's Finger list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Ring.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Ring.Row);
					UpgradeListDBVar.char.SecondarySpecList.Ring.Count = UpgradeListDBVar.char.SecondarySpecList.Ring.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_TRINKET" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[rownum][3] .. " from your Secondary Spec's Trinket list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[rownum][3] .. " from your Secondary Spec's Trinket list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row);
					UpgradeListDBVar.char.SecondarySpecList.Trinket.Count = UpgradeListDBVar.char.SecondarySpecList.Trinket.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_WEAPONMAINHAND" or itemEquipLocation == "INVTYPE_2HWEAPON" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Main.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Main.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[rownum][3] .. " from your Secondary Spec's Main Hand list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[rownum][3] .. " from your Secondary Spec's Main Hand list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Main.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Main.Row);
					UpgradeListDBVar.char.SecondarySpecList.Main.Count = UpgradeListDBVar.char.SecondarySpecList.Main.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_WEAPONOFFHAND" or itemEquipLocation == "INVTYPE_SHIELD" or itemEquipLocation == "INVTYPE_HOLDABLE" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Off.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Off.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[rownum][3] .. " from your Secondary Spec's Off Hand list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[rownum][3] .. " from your Secondary Spec's Off Hand list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Off.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Off.Row);
					UpgradeListDBVar.char.SecondarySpecList.Off.Count = UpgradeListDBVar.char.SecondarySpecList.Off.Count - 1;
				end
			elseif itemEquipLocation == "INVTYPE_RANGED" or itemEquipLocation == "INVTYPE_THROWN" or itemEquipLocation == "INVTYPE_RANGEDRIGHT" or itemEquipLocation == "INVTYPE_RELIC" then
				local rownum = 0;
				repeat
					rownum = rownum + 1;
				until (UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[rownum][8] == itemID or UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[rownum] == nil);
				if UpgradeListDBVar.profile.autodelete.messages then
					if UpgradeListDBVar.profile.autodelete.messagelocation == "chatwindow" then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[rownum][3] .. " from your Secondary Spec's Ranged list.");
					elseif UpgradeListDBVar.profile.autodelete.messagelocation == "scrollwindow" then
						UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Auto-deleting " .. UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[rownum][3] .. " from your Secondary Spec's Ranged list.");
					end
				end
				for i = #UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, rownum, -1 do
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row);
					UpgradeListDBVar.char.SecondarySpecList.Ranged.Count = UpgradeListDBVar.char.SecondarySpecList.Ranged.Count - 1;
				end
			end
		end
	end
end

function UpgradeList:DecideMainorOffHand(itemID, itemEquipLocation, spec)
	MainHandorOffHand:Show();
	MainHandorOffHandOK:SetScript("OnClick", function (self, button, down)
		if WeaponInMain:GetChecked() then
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, spec, "mainhand");
		elseif WeaponInOff:GetChecked() then
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, spec, "offhand");
		end
		MainHandorOffHand:Hide();
		WeaponInOff:SetChecked(false);
		WeaponInMain:SetChecked(true);
		UpgradeListMainFrame:EnableMouse(true)
		CloseButton:EnableMouse(true)
		ToggleButton:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
		OptionsFrame:EnableMouse(true)
		ItemEntryBox:EnableMouse(true)
		DropDown_Button:EnableMouse(true)
		NoteEntryBox:EnableMouse(true)
		PrimarySpecRadioButton:EnableMouse(true)
		SecondarySpecRadioButton:EnableMouse(true)
		priorityfield:EnableMouse(true)
		AddButton:EnableMouse(true)
		tofield:EnableMouse(true)
		fromfield:EnableMouse(true)
		MoveButton:EnableMouse(true)
		DeleteButton:EnableMouse(true)
		deletefield:EnableMouse(true)
	end);
end

function UpgradeList:DecideSpec(itemID, itemEquipLocation, weaponinmainprimary, weaponinoffprimary, weaponinmainsecondary, weaponinoffsecondary)
	SpecInput:Show();
	SpecInputOK:SetScript("OnClick", function (self, button, down)
		if MainSpecCheck:GetChecked() then
			if weaponinmainprimary == true and weaponinoffprimary == true then
				SpecInput:Hide();
				UpgradeList:DecideMainorOffHand(itemID, itemEqiupLocation, "mainspec")
			else
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", nil);
			end
		elseif OffSpecCheck:GetChecked() then
			if weaponinmainsecondary == true and weaponinoffsecondary == true then
				SpecInput:Hide();
				UpgradeList:DecideMainorOffHand(itemID, itemEquipLocation, "offspec")
			else
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", nil);
			end
		end
		SpecInput:Hide();
		OffSpecCheck:SetChecked(false);
		MainSpecCheck:SetChecked(true);
		UpgradeListMainFrame:EnableMouse(true)
		CloseButton:EnableMouse(true)
		ToggleButton:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(true)
		UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(true)
		OptionsFrame:EnableMouse(true)
		ItemEntryBox:EnableMouse(true)
		DropDown_Button:EnableMouse(true)
		NoteEntryBox:EnableMouse(true)
		PrimarySpecRadioButton:EnableMouse(true)
		SecondarySpecRadioButton:EnableMouse(true)
		priorityfield:EnableMouse(true)
		AddButton:EnableMouse(true)
		tofield:EnableMouse(true)
		fromfield:EnableMouse(true)
		MoveButton:EnableMouse(true)
		DeleteButton:EnableMouse(true)
		deletefield:EnableMouse(true)
	end);
end

function UpgradeList:AutoDelete(itemID, itemEquipLocation, primaryspecflag, secondaryspecflag, weaponinmainprimary, weaponinoffprimary, weaponinmainsecondary, weaponinoffsecondary)
	if primaryspecflag == true and secondaryspecflag == true then --if acquired item was in both specs
		if UpgradeListDBVar.profile.autodelete.choice == 1 then
			--Consider the item for the player's main spec
			if weaponinmainprimary == true and weaponinoffprimary == true then --if the acquired item is a 1-handed weapon in the primary spec's Main Hand list and Off Hand list
				if UpgradeListDBVar.profile.onehandweapon.choice == 1 then --Consider the weapon as in the Main Hand list
					UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "mainhand");
				elseif UpgradeListDBVar.profile.onehandweapon.choice == 2 then --Consider the weapon as in the Off Hand list
					UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "offhand");
				elseif UpgradeListDBVar.profile.onehandweapon.choice == 4 then --Ask the user which list the weapon is in
					UpgradeList:DecideMainorOffHand(itemID, itemEquipLocation, "mainspec");
				else
					return;
				end
			elseif weaponinmainprimary == true then
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "mainhand");
			elseif weaponinoffprimary == true then
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "offhand");
			else
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", nil); --Not a 1-handed weapon in main spec
			end
		elseif UpgradeListDBVar.profile.autodelete.choice == 2 then
			--Consider the item for the player's off spec
			if weaponinmainsecondary == true and weaponinoffsecondary == true then --if the acquired item is a 1-handed weapon in the secondary spec's Main Hand list and Off Hand list
				if UpgradeListDBVar.profile.onehandweapon.choice == 1 then --Consider the weapon as in the Main Hand list
					UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "mainhand");
				elseif UpgradeListDBVar.profile.onehandweapon.choice == 2 then --Consider the weapon as in the Off Hand list
					UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "offhand");
				elseif UpgradeListDBVar.profile.onehandweapon.choice == 4 then --Ask the user which list the weapon is in
					UpgradeList:DecideMainorOffHand(itemID, itemEquipLocation, "offspec");
				else --Do nothing
					return;
				end
			elseif weaponinmainsecondary == true then
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "mainhand");
			elseif weaponinoffsecondary == true then
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "offhand");
			else
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", nil); --Not a 1-handed weapon in off spec
			end
		elseif UpgradeListDBVar.profile.autodelete.choice == 4 then
			UpgradeList:DecideSpec(itemID, itemEquipLocation, weaponinmainprimary, weaponinoffprimary, weaponinmainsecondary, weaponinoffsecondary); --Figures out spec & if the item is a 1-handed weapon
		else
			return;
		end
	elseif primaryspecflag == true then --if acquired item was in main spec list only
		--Delete the item and those below it from the main spec list
		if weaponinmainprimary == true and weaponinoffprimary == true then --if the acquired item is a 1-handed weapon in the primary spec's Main Hand list and Off Hand list
			if UpgradeListDBVar.profile.onehandweapon.choice == 1 then --Consider the weapon as in the Main Hand list
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "mainhand");
			elseif UpgradeListDBVar.profile.onehandweapon.choice == 2 then --Consider the weapon as in the Off Hand list
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "offhand");
			elseif UpgradeListDBVar.profile.onehandweapon.choice == 4 then --Ask the user which list the weapon is in
				UpgradeList:DecideMainorOffHand(itemID, itemEquipLocation, "mainspec");
			else
				return;
			end
		elseif weaponinmainprimary == true and weaponinoffprimary == false then --if the acquired item is a 1-handed weapon in the primary spec's Main Hand list only
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "mainhand");
		elseif weaponinmainprimary == false and weaponinoffprimary == true then --if the acquired item is a 1-handed weapon in the primary spec's Off Hand list only
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "offhand");
		else
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", nil); --Not a 1-handed weapon in main spec
		end
	else -- if acquired item was in off spec list only
		--Delete the item and those below it from the off spec list
		if weaponinmainsecondary == true and weaponinoffsecondary == true then --if the acquired item is a 1-handed weapon in the secondary spec's Main Hand list and Off Hand list
			if UpgradeListDBVar.profile.onehandweapon.choice == 1 then --Consider the weapon as in the Main Hand list
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "mainhand");
			elseif UpgradeListDBVar.profile.onehandweapon.choice == 2 then --Consider the weapon as in the Off Hand list
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "offhand");
			elseif UpgradeListDBVar.profile.onehandweapon.choice == 4 then --Ask the user which list the weapon is in
				UpgradeList:DecideMainorOffHand(itemID, itemEquipLocation, "offspec");
			else
				return;
			end
		elseif weaponinmainsecondary == true and weaponinoffsecondary == false then --if the acquired item is a 1-handed weapon in the secondary spec's Main Hand list only
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "mainhand");
		elseif weaponinmainsecondary == false and weaponinoffsecondary == true then --if the acquired item is a 1-handed weapon in the secondary spec's Off Hand list only
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "offhand");
		else
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", nil); --Not a 1-handed weapon in off spec
		end
	end
end

function UpgradeList:Compare(itemID, itemEquipLocation, attainability)
	local primaryspecflag = false;
	local secondaryspecflag = false;
	local weaponinmainprimary = false;
	local weaponinoffprimary = false;
	local weaponinmainsecondary = false;
	local weaponinoffsecondary = false;
	local otherflag = false;
	if itemEquipLocation == "INVTYPE_HEAD" then
		if UpgradeListDBVar.char.PrimarySpecList.Head.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Head.Row);
		end
	elseif itemEquipLocation == "INVTYPE_NECK" then
		if UpgradeListDBVar.char.PrimarySpecList.Neck.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Neck.Row);
		end
	elseif itemEquipLocation == "INVTYPE_SHOULDER" then
		if UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row);
		end
	elseif itemEquipLocation == "INVTYPE_CLOAK" then
		if UpgradeListDBVar.char.PrimarySpecList.Back.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Back.Row);
		end
	elseif itemEquipLocation == "INVTYPE_CHEST" or itemEquipLocation == "INVTYPE_ROBE" then
		if UpgradeListDBVar.char.PrimarySpecList.Chest.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Chest.Row);
		end
	elseif itemEquipLocation == "INVTYPE_WRIST" then
		if UpgradeListDBVar.char.PrimarySpecList.Wrist.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Wrist.Row);
		end
	elseif itemEquipLocation == "INVTYPE_HAND" then
		if UpgradeListDBVar.char.PrimarySpecList.Hand.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][3]);
							end						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Hand.Row);
		end
	elseif itemEquipLocation == "INVTYPE_WAIST" then
		if UpgradeListDBVar.char.PrimarySpecList.Waist.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Waist.Row);
		end
	elseif itemEquipLocation == "INVTYPE_LEGS" then
		if UpgradeListDBVar.char.PrimarySpecList.Leg.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Leg.Row);
		end
	elseif itemEquipLocation == "INVTYPE_FEET" then
		if UpgradeListDBVar.char.PrimarySpecList.Foot.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Foot.Row);
		end
	elseif itemEquipLocation == "INVTYPE_FINGER" then
		if UpgradeListDBVar.char.PrimarySpecList.Ring.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Ring.Row);
		end
	elseif itemEquipLocation == "INVTYPE_TRINKET" then
		if UpgradeListDBVar.char.PrimarySpecList.Trinket.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Trinket.Row);
		end
	elseif itemEquipLocation == "INVTYPE_2HWEAPON" or itemEquipLocation == "INVTYPE_WEAPONMAINHAND" then
		if UpgradeListDBVar.char.PrimarySpecList.Main.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Main.Row);
		end
	elseif itemEquipLocation == "INVTYPE_SHIELD" or itemEquipLocation == "INVTYPE_OFFHANDWEAPON" or itemEquipLocation == "INVTYPE_HOLDABLE" then
		if UpgradeListDBVar.char.PrimarySpecList.Off.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Off.Row);
		end
	elseif itemEquipLocation == "INVTYPE_RANGED" or itemEquipLocation == "INVTYPE_THROWN" or itemEquipLocation == "INVTYPE_RANGEDRIGHT" or itemEquipLocation == "INVTYPE_RELIC" then
		if UpgradeListDBVar.char.PrimarySpecList.Ranged.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Ranged.Row);
		end
	elseif itemEquipLocation == "INVTYPE_WEAPON" then
		if UpgradeListDBVar.char.PrimarySpecList.Main.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
						weaponinmainprimary = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Main.Row);
		end
		if UpgradeListDBVar.char.PrimarySpecList.Off.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential and weaponinmainprimary == false then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential and weaponinmainprimary == false then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired and weaponinmainprimary == false then
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.acquired and weaponinmainprimary == false then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						primaryspecflag = true;
						weaponinoffprimary = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Off.Row);
		end
	else
		if UpgradeListDBVar.char.PrimarySpecList.Other.Count > 1 then
			local i = 0;
			repeat
				i = i + 1;
				if itemID == UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][8] then
					if attainability == "potential" then
						if UpgradeListDBVar.profile.messages.potential then
							if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Item Detected in Primary Spec's \"Other\" Tab: " .. UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Item Detected in Primary Spec's \"Other\" Tab: " .. UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.sound.potential then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
						end
					else
						if UpgradeListDBVar.profile.messages.acquired then					
							if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
								DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][3]);
							elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
								UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Primary Spec: " .. UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][3]);
							end
						end
						if UpgradeListDBVar.profile.messages.acquired then
							PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
						end
						otherflag = true;
					end
				end
			until (itemID == UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][8] or i == #UpgradeListDBVar.char.PrimarySpecList.Other.Row);
		end
	end
	if GetNumTalentGroups("player") > 1 then --If the player has a second spec
		if itemEquipLocation == "INVTYPE_HEAD" then
			if UpgradeListDBVar.char.SecondarySpecList.Head.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Head.Row);
			end
		elseif itemEquipLocation == "INVTYPE_NECK" then
			if UpgradeListDBVar.char.SecondarySpecList.Neck.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Neck.Row);
			end
		elseif itemEquipLocation == "INVTYPE_SHOULDER" then
			if UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row);
			end
		elseif itemEquipLocation == "INVTYPE_CLOAK" then
			if UpgradeListDBVar.char.SecondarySpecList.Back.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Back.Row);
			end
		elseif itemEquipLocation == "INVTYPE_CHEST" or itemEquipLocation == "INVTYPE_ROBE" then
			if UpgradeListDBVar.char.SecondarySpecList.Chest.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Chest.Row);
			end
		elseif itemEquipLocation == "INVTYPE_WRIST" then
			if UpgradeListDBVar.char.SecondarySpecList.Wrist.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Wrist.Row);
			end
		elseif itemEquipLocation == "INVTYPE_HAND" then
			if UpgradeListDBVar.char.SecondarySpecList.Hand.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Hand.Row);
			end
		elseif itemEquipLocation == "INVTYPE_WAIST" then
			if UpgradeListDBVar.char.SecondarySpecList.Waist.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Waist.Row);
			end
		elseif itemEquipLocation == "INVTYPE_LEGS" then
			if UpgradeListDBVar.char.SecondarySpecList.Leg.Count > 1 then
				local i = 0;
				repeat
					 i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Leg.Row);
			end
		elseif itemEquipLocation == "INVTYPE_FEET" then
			if UpgradeListDBVar.char.SecondarySpecList.Foot.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Foot.Row);
			end
		elseif itemEquipLocation == "INVTYPE_FINGER" then
			if UpgradeListDBVar.char.SecondarySpecList.Ring.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Ring.Row);
			end
		elseif itemEquipLocation == "INVTYPE_TRINKET" then
			if UpgradeListDBVar.char.SecondarySpecList.Trinket.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Trinket.Row);
			end
		elseif itemEquipLocation == "INVTYPE_2HWEAPON" or itemEquipLocation == "INVTYPE_WEAPONMAINHAND" then
			if UpgradeListDBVar.char.SecondarySpecList.Main.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Main.Row);
			end
		elseif itemEquipLocation == "INVTYPE_SHIELD" or itemEquipLocation == "INVTYPE_OFFHANDWEAPON" or itemEquipLocation == "INVTYPE_HOLDABLE" then
			if UpgradeListDBVar.char.SecondarySpecList.Off.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Off.Row);
			end
		elseif itemEquipLocation == "INVTYPE_RANGED" or itemEquipLocation == "INVTYPE_THROWN" or itemEquipLocation == "INVTYPE_RANGEDRIGHT" or itemEquipLocation == "INVTYPE_RELIC" then
			if UpgradeListDBVar.char.SecondarySpecList.Ranged.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Ranged.Row);
			end
		elseif itemEquipLocation == "INVTYPE_WEAPON" then
			if UpgradeListDBVar.char.SecondarySpecList.Main.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
							weaponinmainsecondary = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Main.Row);
			end
			if UpgradeListDBVar.char.SecondarySpecList.Off.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential and weaponinmainsecondary == false then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Detected for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential and primaryspecflag == false and weaponinmainsecondary == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired and primaryspecflag == false and weaponinmainsecondary == false then
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Upgrade Acquired for Secondary Spec: " .. UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.acquired and primaryspecflag == false and weaponinmainsecondary == false then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							secondaryspecflag = true;
							weaponinoffsecondary = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Off.Row);
			end
		else
			if UpgradeListDBVar.char.SecondarySpecList.Other.Count > 1 then
				local i = 0;
				repeat
					i = i + 1;
					if itemID == UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][8] then
						if attainability == "potential" then
							if UpgradeListDBVar.profile.messages.potential and otherflag == false then
								if UpgradeListDBVar.profile.messages.potentiallocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Item Detected in Secondary Spec's \"Other\" Tab: " .. UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.potentiallocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Item Detected in Secondary Spec's \"Other\" Tab: " .. UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.sound.potential then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.potentialchoice))
							end
						else
							if UpgradeListDBVar.profile.messages.acquired then					
								if UpgradeListDBVar.profile.messages.acquiredlocation == "chatwindow" then
									DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r Item Acquired in Secondary Spec's \"Other\" Tab: " .. UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][3]);
								elseif UpgradeListDBVar.profile.messages.acquiredlocation == "scrollwindow" then
									UpgradeListDBVar.profile.messages.scrollwindow:AddMessage("Item Acquired in Secondary Spec's \"Other\" Tab: " .. UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][3]);
								end
							end
							if UpgradeListDBVar.profile.messages.acquired then
								PlaySoundFile(LSM:Fetch("sound", UpgradeListDBVar.profile.sound.acquiredchoice))
							end
							otherflag = true;
						end
					end
				until (itemID == UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][8] or i == #UpgradeListDBVar.char.SecondarySpecList.Other.Row);
			end
		end
	end
	if otherflag == false and (primaryspecflag == true or secondaryspecflag == true) then --if item was not in "Other" tab ("Other" tab does not auto-delete) and was acquired
		if UpgradeListDBVar.profile.autodelete.enable then
			if itemEquipLocation ~= "INVTYPE_FINGER" and itemEquipLocation ~= "INVTYPE_TRINKET" or (itemEquipLocation == "INVTYPE_FINGER" and UpgradeListDBVar.profile.ignoreflags.rings == false) or (itemEquipLocation == "INVTYPE_TRINKET" and UpgradeListDBVar.profile.ignoreflags.trinkets == false) then --if the acquired item is not a ring or trinket, or if it was a ring and the ignore rings checkbox is unchecked, or if it was a trinket and the ignore trinkets checkbox is unchecked
				UpgradeList:AutoDelete(itemID, itemEquipLocation, primaryspecflag, secondaryspecflag, weaponinmainprimary, weaponinoffprimary, weaponinmainsecondary, weaponinoffsecondary);
			elseif itemEquipLocation == "INVTYPE_FINGER" and UpgradeListDBVar.profile.ignoreflags.rings == true then
				local itemName, itemLink = GetItemInfo(itemID);
				DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r " .. itemLink .. " acquired, remember to manually update your Ring list!");
			elseif itemEquipLocation == "INVTYPE_TRINKET" and UpgradeListDBVar.profile.ignoreflags.trinkets == true then
				local itemName, itemLink = GetItemInfo(itemID);
				DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r " .. itemLink .. " acquired, remember to manually update your Trinket list!");
			end
		end
	elseif otherflag == true then
		local itemName, itemLink = GetItemInfo(itemID);
		DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r " .. itemLink .. " acquired, remember to manually update your Other list!");
	end
	primaryspecflag = false;
	secondaryspecflag = false;
	weaponinmainprimary = false;
	weaponinoffprimary = false;
	weaponinmainsecondary = false;
	weaponinoffsecondary = false;
	otherflag = false;
end

function UpgradeList:ToggleOptions()
	if OptionsFrame:IsShown() then
		OptionsFrame:Hide()
		UpgradeListDBVar.profile.mainframe.showoptions = false;
	else
		OptionsFrame:Show()
		UpgradeListDBVar.profile.mainframe.showoptions = true;
	end
end
--[[
function UpgradeList:HighlightGear(name, difficulty)
	local count = 1;
	local InstancyHighlightColor = {
		["r"] = 0.0,
		["g"] = 0.0,
		["b"] = 0.0,
		["a"] = 1.0,
	};
	while UpgradeListDBVar.char.PrimarySpecList.Head.Row[count] ~= nil do
		if UpgradeListDBVar.char.PrimarySpecList.Head.Row[count][5] == name and UpgradeListDBVar.char.PrimarySpecList.Head.Row[count][4] == difficulty then
			--Highlight that particular row
			UpgradeListDBVar.char.SavedOptions.tableUL
		end
		count = count + 1;
	end
end
--]]
--function UpgradeList:PLAYER_GUILD_UPDATE() --Redo the dropdown list if a player's guild info changes
	--UIDropDownMenu_Initialize(self, DropDown_InitializeDropDown)
--end

function UpgradeList:CHAT_MSG_LOOT(eventName, arg1)
	if string.match(arg1, 'You receive loot: ') or string.match(arg1, 'You receive item: ') then
		local minitable = { strsplit(" [", arg1) };
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice;
		for i = 1, #minitable, 1 do
			if string.sub(minitable[i], 1, 1) == "|" then --In minitable, if the first character of a variable is a "|" symbol, that is the item string, so use that entry of minitable to get the itemEquipLoc
				itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(minitable[i]);
			end
		end
		local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
		UpgradeList:Compare(ID, itemEquipLoc, "acquired");
	end
end

function UpgradeList:CHAT_MSG_SYSTEM(eventName, arg1)
	if string.match(arg1, 'Received item:') or string.match(arg1, 'Received .. of item:') then
		UpgradeList:CHAT_MSG_LOOT(self, arg1);
		local minitable = { strsplit(" [", arg1) };
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice;
		for i = 1, #minitable, 1 do
			if string.sub(minitable[i], 1, 1) == "|" then --In minitable, if the first character of a variable is a "|" symbol, that is the item string, so use that entry of minitable to get the itemEquipLoc
				itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(minitable[i]);
			end
		end
		local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
		UpgradeList:Compare(ID, itemEquipLoc, "acquired");	
	end
end

function UpgradeList:LOOT_OPENED()
	for index = 1, GetNumLootItems() do
		if (LootSlotIsItem(index)) then
			local itemLink = GetLootSlotLink(index);
			local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemLink);
			UpgradeList:Compare(ID, itemEquipLoc, "potential");
		end
	end
end

function UpgradeList:START_LOOT_ROLL(eventName, arg1, arg2) --This and Loot Opened fire when looting something in a group, figure out how to only have Loot Opened fire when opening loot.
	local itemLink = GetLootRollItemLink(arg1);
	local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemLink);
	UpgradeList:Compare(ID, itemEquipLoc, "potential");
end

function UpgradeList:PLAYER_ENTERING_WORLD()
	local inInstance, instanceType = IsInInstance();
	if inInstance == 1 and (instanceType == "party" or instanceType == "raid") then --if you're in an instance
		local instanceflag = true;
		local name, instancetype, difficultyIndex, difficultyName, maxPlayers, dynamicDifficulty, isDynamic = GetInstanceInfo();
		if instanceType == "party" and difficultyIndex == 1 then --Normal 5 mans
			UpgradeList:RefreshWindow(name, "Normal", instanceflag);
		elseif instanceType == "party" and difficultyIndex == 2 then --Heroic 5 mans
			UpgradeList:RefreshWindow(name, "Heoric", instanceflag);
		elseif instanceType == "raid" and (difficultyIndex == 1 or difficultyIndex == 2) then --10/25 man Normal raids
			UpgradeList:RefreshWindow(name, "Normal", instanceflag);
		elseif instanceType == "raid" and (difficultyIndex == 3 or difficultyIndex == 4) then --10/25 man Heroic raids
			UpgradeList:RefreshWindow(name, "Heroic", instanceflag);
		end
	end
end

--function UpgradeList:UPDATE_FACTION()

--end

local function ScanQuestItems()
	local num = GetNumQuestChoices();
	if num > 0 then
		for i = 1, num, 1 do
			local itemLink = GetQuestItemLink("choice", i);
			if itemLink == nil then
				print("UpgradeList: Error occurred while scanning quest items.");
			else
				local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
				local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemLink);
				UpgradeList:Compare(ID, itemEquipLoc, "potential");
			end
		end
	end
end

function UpgradeList:QUEST_DETAIL()
	UpgradeList_wait(.5, ScanQuestItems)
end

function UpgradeList:QUEST_COMPLETE()
	UpgradeList_wait(.5, ScanQuestItems)
end

function UpgradeList:CHAT_MSG_RAID(arg1, arg2, arg3)
	local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()
	if lootmethod == "master" and UnitInRaid("player") then
		local name = GetRaidRosterInfo(masterlooterRaidID)
		if arg3 == name and name ~= UnitName("player") then
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(arg2);
			if itemLink then
				local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
				UpgradeList:Compare(ID, itemEquipLoc, "potential");
			end
		end
	end
end

function UpgradeList:CHAT_MSG_RAID_LEADER(arg1, arg2, arg3)
	UpgradeList:CHAT_MSG_RAID(arg1, arg2, arg3)
end

function UpgradeList:CHAT_MSG_RAID_WARNING(arg1, arg2, arg3)
	local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()
	if lootmethod == "master" and UnitInRaid("player") then
		local name = GetRaidRosterInfo(masterlooterRaidID)
		if arg3 == name and name ~= UnitName("player") then
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(arg2);
			if itemLink then
				local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
				UpgradeList:Compare(ID, itemEquipLoc, "potential");
			end
		end
	end
end

function UpgradeList:ACHIEVEMENT_EARNED(eventName, arg1) --Enables the checkbox and radio button for the secondary spec if the player earns the Duel-Talent specialization achievement.
	if arg1 == 2716 then
		UpgradeListDBVar.char.SavedOptions.SecondaryCheck:Enable();
		SecondarySpecRadioButton:Enable();
	end
end

function UpgradeList:ChatEdit_InsertLink(lnk) --Called when a player shift-clicks an item, if the ItemEntryBox has focus, it will add the item's link to the box.
	if ItemEntryBox:HasFocus() then
		ItemEntryBox:SetText(lnk)
	end
end


function UpgradeList:OnEnable()
	--Register for Events
	--UpgradeList:RegisterEvent("PLAYER_GUILD_UPDATE")
	UpgradeList:RegisterEvent("CHAT_MSG_LOOT")
	UpgradeList:RegisterEvent("CHAT_MSG_SYSTEM")
	UpgradeList:RegisterEvent("LOOT_OPENED")
	UpgradeList:RegisterEvent("START_LOOT_ROLL")
	UpgradeList:RegisterEvent("PLAYER_ENTERING_WORLD")
	--UpgradeList:RegisterEvent("UPDATE_FACTION")
	UpgradeList:RegisterEvent("QUEST_DETAIL")
	UpgradeList:RegisterEvent("QUEST_COMPLETE")
	UpgradeList:RegisterEvent("CHAT_MSG_RAID")
	UpgradeList:RegisterEvent("CHAT_MSG_RAID_LEADER")
	UpgradeList:RegisterEvent("CHAT_MSG_RAID_WARNING")
	if GetNumTalentGroups("player") == 1 then
		UpgradeList:RegisterEvent("ACHIEVEMENT_EARNED")
	end
	
	--Hooks
	UpgradeList:SecureHook("ChatEdit_InsertLink") --Happens when a player shift-clicks an item
	
	UpgradeList:DrawUI()
	
end